<template>
    <div>
        <el-form :inline="true" :model="query" class="query-form" size="mini">
            <el-row>
                <el-form-item class="query-form-item">
                    <el-input v-model="filterQuery.genKey" placeholder="记录ID"></el-input>
                </el-form-item>

                <el-form-item class="query-form-item">
                    <el-select v-model="filterQuery.status" placeholder="处理状态">
                        <el-option label="全部" value=""></el-option>
                        <el-option label="处理中" value="0"></el-option>
                        <el-option label="已处理" value="1"></el-option>
                        <el-option label="异常" value="2"></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item>
                    <el-button-group style="display:flex;">
                        <el-button type="primary" icon="el-icon-refresh" @click="onReset"></el-button>
                        <el-button type="primary" icon="search" @click="getList">查询</el-button>
                        <el-upload
                            :action="uploadFileUrl"
                            multiple
                            :limit="1"
                            :data="uploadData"
                            :show-file-list="false"
                            :on-success="handleChange"
                            :file-list="fileList"
                        >
                            <el-button size="mini" type="primary">导入往来单位信息</el-button>
                        </el-upload>
                        <!--<el-button type="primary" icon="search" @click="jumpDl">模板下载
                         </el-button>-->
                    </el-button-group>

                </el-form-item>
            </el-row>
        </el-form>

        <el-table
            v-loading="loading"
            :data="list"
            style="width: 100%"
            @selection-change="handleSelectionChange"
        >
            <el-table-column label="序号" type="index"></el-table-column>
            <el-table-column
                label="记录ID"
                prop="genKey"
                show-overflow-tooltip
            ></el-table-column>

            <el-table-column
                label="来源"
                prop="fromType"
                show-overflow-tooltip
            >
            </el-table-column>
            <el-table-column
                label="更新日期"
                prop="updateTime"
                show-overflow-tooltip
            ></el-table-column>
            <el-table-column
                label="状态"
                prop="status"
                show-overflow-tooltip
            >
                <template slot-scope="scope">
                    <el-tag
                        :type="statusFilterType(scope.row.status)"
                    >{{ status[scope.row.status] }}
                    </el-tag
                    >
                </template>
            </el-table-column>
            <el-table-column label="操作" fixed="right" width="160">
                <template slot-scope="scope">
                    <el-button
                        type="text"
                        size="small"
                        @click.native.stop="handleDetailClick(scope.row)"
                    >详情
                    </el-button
                    >
                    <el-button
                        type="text"
                        size="small"
                        @click.native.stop="deleteDialog(scope.row.id)"
                    >删除
                    </el-button
                    >
                </template>
            </el-table-column>
        </el-table>


        <el-dialog
            title="往来单位信息导入详情"
            :visible.sync="corpImportDetailVisible"
            width="85%"
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            v-if="corpImportDetailVisible"
        >
            <corpImportDetail :currentRow="currentRow" :closeDialog="corpImportDetail"></corpImportDetail>
        </el-dialog>

        <el-pagination
            :page-size="filterQuery.limit"
            @current-change="handleCurrentChange"
            layout="prev, pager, next"
            :total="total"
            :current-page="filterQuery.page"
        ></el-pagination>
    </div>
</template>

<script>
import axios from "axios";
import {filterLog, deleteLog} from "../../api/basic/corpImport";
import {getBasicThirdSys} from "../../api/basic/basicThirdSys";
import corpImportDetail from "./CorpImportDetail";

export default {
    data() {
        return {
            filterQuery: {
                genKey: null,
                status: null,
                fromType: null,
                page: 1,
                limit: 20,
                thirdSysFk: null,
            },
            corpImportDetailVisible: false,
            checked: false,
            list: [],
            detailList: [],
            thirdSys: [],
            thirdSysDetail: null,
            total: 0,
            currentRow: null,
            status: {
                0: "等待处理",
                1: "正在处理",
                2: "处理异常",
                3: "处理完成"
            },
            uploadFileUrl: null,
            uploadData: {
                thirdSys: "thirdId",
            },
            templateDlUrl: null,
        };
    },

    methods: {
        onReset() {
            this.$router.push({
                path: "",
            });
            this.filterQuery = {
                fromType: null,
                genKey: null,
                status: null,
                page: 1,
                limit: 20,
                thirdSysFk: null,
            };
            this.getList();
        },
        getList() {
            this.loading = true;
            filterLog(this.filterQuery)
                .then((response) => {
                    this.loading = false;
                    this.list = response.data.list || [];
                    this.total = response.data.total || 0;
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                    this.total = 0;
                });
        },

        handleDetailClick(row) {
            this.currentRow = row;
            console.log(this.currentRow.genKey)
            this.corpImportDetailVisible = true;

        },
        cancelDialog() {
            this.corpImportDetailVisible = false;
        },
        handleCurrentChange(val) {
            this.filterQuery.page = val;
            this.getList();
        },
        deleteDialog(rowId) {
            this.$confirm("此操作将删除该往来单位信息, 是否继续?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    let dQuery = {
                        id: rowId,
                    };
                    deleteLog(dQuery)
                        .then((response) => {
                            this.loading = false;
                            if (response.code == 20000) {
                                this.$message.success("删除成功");
                            } else {
                                this.$message.error(response.message);
                            }
                            this.getList();
                        })
                        .catch(() => {
                            this.loading = false;
                        });
                })
                .catch(() => {
                });
        },
        getBasicThirdSys() {
            let query = {
                enabled: true,
            };
            getBasicThirdSys(query)
                .then((response) => {
                    this.thirdSys = response.data.list || [];
                    // this.filterQuery.thirdSysFk = this.thirdSys[0].thirdId;
                    this.getList();
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                });
            axios.get("./config.json").then(res => {
                // 基础地址
                let response = res.data.BASE_URL;
                this.uploadFileUrl = response + "/udiwms/corps/importLog/upload";
            });
            axios.get("./config.json").then(res => {
                let response = res.data.SERVER_IP;
                this.templateDlUrl = response + "/已对照往来单位模板.xlsx";
            });
        },
        jumpDl() {
            window.open(this.templateDlUrl, '_blank');
        },
        handleChange(response, files, fileList) {
            console.log(response);
            if (response.code != 20000) {
                this.$message.error(response.message);
            } else {
                // console.log(files[0] + "\n" + this.fileList[0] + "\n" + fileList[0]);
                this.$message.success(response.data);
                this.getList();
            }
        },
        statusFilterType(status) {
            const statusMap = {
                0: "warning",
                1: "warning",
                2: "danger",
                3: "success",
            };
            return statusMap[status];
        },
    },
    mounted() {
    },
    components: {corpImportDetail},
    created() {
        this.getBasicThirdSys();
        this.getList();
    },
};
</script>
<style>
.itemTag {
    float: left;
    text-align: left;
    margin-top: 10px;
    width: 100px;
}

.text {
    font-size: 13px;
    font-family: "Microsoft YaHei";
}

.el-row {
    display: flex;
    flex-wrap: wrap;

}

.el-col {
    border-radius: 4px;
    flex-wrap: wrap;
}
</style>
